#!/usr/bin/python2.2

import sys, cgi, cgitb; cgitb.enable()

form = cgi.FieldStorage()
form.__call__ = lambda s: form[s].value

def serve(status, body): 
   sys.stdout.write("Status: %s\r\n" % status)
   sys.stdout.write("Content-Type: text/html; charset=utf-8\r\n\r\n")
   if not body.startswith('<!DOCTYPE'): 
      body = '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN">\n' + body
   if not body.endswith('\n'): body += '\n'
   sys.stdout.write(body)
   sys.exit()

def post(): 
   body = """
   <form method="POST" action="./">
   <div>Title: <input type="text" name="title" size="17"></div>
   <div><textarea rows="10" cols="79" name="text"></textarea></div>
   <div><input type="submit" value="Create Entry"></div>
   </form>

   <form method="POST" action="./">
   <div>File: <input type="text" name="build" size="17"> 
      <input type="submit" value="Build"></div>
   </form>

   <form method="GET" action="./post.cgi">
   <div>Number: <input type="text" name="change" size="17"> 
      <input type="submit" value="Change"></div>
   </form>

   <form method="GET" action="./post.cgi">
   <div>Number: <input type="text" name="delete" size="17"> 
      <input type="submit" value="Delete"></div>
   </form>
   """
   serve(200, body)

class Entry(dict): 
   def __init__(self, fn): 
      self['number'] = str(fn)
      f = open("%s.txt" % fn)
      self['title'] = f.readline().rstrip()
      self['date'] = f.readline().rstrip()
      self['content'] = f.read()
      f.close()

def change(): 
   n = form('change')
   try: entry = Entry(n)
   except IOError: title, text = '*** Entry does not exist ***', ''
   else: 
      title = entry['title']
      text = entry['content']

   body = """
   <form method="POST" action="./%s">
   <div><input type="text" name="title" size="17" value="%s"></div>
   <div><textarea rows="15" cols="79" name="text">%s</textarea></div>
   <div><input type="submit" value="Change Entry"></div>
   </form>
   """ % (n, title, text)
   serve(200, body)

def delete(): 
   n = form('delete')
   entry = Entry(n)
   title = entry['title']

   body = """
   <form method="POST" action="./%s">
   <div>Delete "%s"?: <input type="hidden" name="action" value="delete"> 
      <input type="submit" value="Delete Entry"></div>
   </form>
   """ % (n, title)
   serve(200, body)

def main(): 
   if form.has_key('change'): change()
   elif form.has_key('delete'): delete()
   else: post()

if __name__=="__main__": 
   main()
